// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"
	"time"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"gitlab.com/oscar.alberto.tovar/wdym/ent/definition"
	"gitlab.com/oscar.alberto.tovar/wdym/ent/predicate"
	"gitlab.com/oscar.alberto.tovar/wdym/ent/term"
)

// DefinitionUpdate is the builder for updating Definition entities.
type DefinitionUpdate struct {
	config
	hooks     []Hook
	mutation  *DefinitionMutation
	modifiers []func(*sql.UpdateBuilder)
}

// Where appends a list predicates to the DefinitionUpdate builder.
func (du *DefinitionUpdate) Where(ps ...predicate.Definition) *DefinitionUpdate {
	du.mutation.Where(ps...)
	return du
}

// SetUpdatedAt sets the "updated_at" field.
func (du *DefinitionUpdate) SetUpdatedAt(t time.Time) *DefinitionUpdate {
	du.mutation.SetUpdatedAt(t)
	return du
}

// SetText sets the "text" field.
func (du *DefinitionUpdate) SetText(s string) *DefinitionUpdate {
	du.mutation.SetText(s)
	return du
}

// SetTermID sets the "term" edge to the Term entity by ID.
func (du *DefinitionUpdate) SetTermID(id int) *DefinitionUpdate {
	du.mutation.SetTermID(id)
	return du
}

// SetNillableTermID sets the "term" edge to the Term entity by ID if the given value is not nil.
func (du *DefinitionUpdate) SetNillableTermID(id *int) *DefinitionUpdate {
	if id != nil {
		du = du.SetTermID(*id)
	}
	return du
}

// SetTerm sets the "term" edge to the Term entity.
func (du *DefinitionUpdate) SetTerm(t *Term) *DefinitionUpdate {
	return du.SetTermID(t.ID)
}

// Mutation returns the DefinitionMutation object of the builder.
func (du *DefinitionUpdate) Mutation() *DefinitionMutation {
	return du.mutation
}

// ClearTerm clears the "term" edge to the Term entity.
func (du *DefinitionUpdate) ClearTerm() *DefinitionUpdate {
	du.mutation.ClearTerm()
	return du
}

// Save executes the query and returns the number of nodes affected by the update operation.
func (du *DefinitionUpdate) Save(ctx context.Context) (int, error) {
	du.defaults()
	return withHooks(ctx, du.sqlSave, du.mutation, du.hooks)
}

// SaveX is like Save, but panics if an error occurs.
func (du *DefinitionUpdate) SaveX(ctx context.Context) int {
	affected, err := du.Save(ctx)
	if err != nil {
		panic(err)
	}
	return affected
}

// Exec executes the query.
func (du *DefinitionUpdate) Exec(ctx context.Context) error {
	_, err := du.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (du *DefinitionUpdate) ExecX(ctx context.Context) {
	if err := du.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (du *DefinitionUpdate) defaults() {
	if _, ok := du.mutation.UpdatedAt(); !ok {
		v := definition.UpdateDefaultUpdatedAt()
		du.mutation.SetUpdatedAt(v)
	}
}

// check runs all checks and user-defined validators on the builder.
func (du *DefinitionUpdate) check() error {
	if v, ok := du.mutation.Text(); ok {
		if err := definition.TextValidator(v); err != nil {
			return &ValidationError{Name: "text", err: fmt.Errorf(`ent: validator failed for field "Definition.text": %w`, err)}
		}
	}
	return nil
}

// Modify adds a statement modifier for attaching custom logic to the UPDATE statement.
func (du *DefinitionUpdate) Modify(modifiers ...func(u *sql.UpdateBuilder)) *DefinitionUpdate {
	du.modifiers = append(du.modifiers, modifiers...)
	return du
}

func (du *DefinitionUpdate) sqlSave(ctx context.Context) (n int, err error) {
	if err := du.check(); err != nil {
		return n, err
	}
	_spec := sqlgraph.NewUpdateSpec(definition.Table, definition.Columns, sqlgraph.NewFieldSpec(definition.FieldID, field.TypeInt))
	if ps := du.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := du.mutation.UpdatedAt(); ok {
		_spec.SetField(definition.FieldUpdatedAt, field.TypeTime, value)
	}
	if value, ok := du.mutation.Text(); ok {
		_spec.SetField(definition.FieldText, field.TypeString, value)
	}
	if du.mutation.TermCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   definition.TermTable,
			Columns: []string{definition.TermColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(term.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := du.mutation.TermIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   definition.TermTable,
			Columns: []string{definition.TermColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(term.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	_spec.AddModifiers(du.modifiers...)
	if n, err = sqlgraph.UpdateNodes(ctx, du.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{definition.Label}
		} else if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return 0, err
	}
	du.mutation.done = true
	return n, nil
}

// DefinitionUpdateOne is the builder for updating a single Definition entity.
type DefinitionUpdateOne struct {
	config
	fields    []string
	hooks     []Hook
	mutation  *DefinitionMutation
	modifiers []func(*sql.UpdateBuilder)
}

// SetUpdatedAt sets the "updated_at" field.
func (duo *DefinitionUpdateOne) SetUpdatedAt(t time.Time) *DefinitionUpdateOne {
	duo.mutation.SetUpdatedAt(t)
	return duo
}

// SetText sets the "text" field.
func (duo *DefinitionUpdateOne) SetText(s string) *DefinitionUpdateOne {
	duo.mutation.SetText(s)
	return duo
}

// SetTermID sets the "term" edge to the Term entity by ID.
func (duo *DefinitionUpdateOne) SetTermID(id int) *DefinitionUpdateOne {
	duo.mutation.SetTermID(id)
	return duo
}

// SetNillableTermID sets the "term" edge to the Term entity by ID if the given value is not nil.
func (duo *DefinitionUpdateOne) SetNillableTermID(id *int) *DefinitionUpdateOne {
	if id != nil {
		duo = duo.SetTermID(*id)
	}
	return duo
}

// SetTerm sets the "term" edge to the Term entity.
func (duo *DefinitionUpdateOne) SetTerm(t *Term) *DefinitionUpdateOne {
	return duo.SetTermID(t.ID)
}

// Mutation returns the DefinitionMutation object of the builder.
func (duo *DefinitionUpdateOne) Mutation() *DefinitionMutation {
	return duo.mutation
}

// ClearTerm clears the "term" edge to the Term entity.
func (duo *DefinitionUpdateOne) ClearTerm() *DefinitionUpdateOne {
	duo.mutation.ClearTerm()
	return duo
}

// Where appends a list predicates to the DefinitionUpdate builder.
func (duo *DefinitionUpdateOne) Where(ps ...predicate.Definition) *DefinitionUpdateOne {
	duo.mutation.Where(ps...)
	return duo
}

// Select allows selecting one or more fields (columns) of the returned entity.
// The default is selecting all fields defined in the entity schema.
func (duo *DefinitionUpdateOne) Select(field string, fields ...string) *DefinitionUpdateOne {
	duo.fields = append([]string{field}, fields...)
	return duo
}

// Save executes the query and returns the updated Definition entity.
func (duo *DefinitionUpdateOne) Save(ctx context.Context) (*Definition, error) {
	duo.defaults()
	return withHooks(ctx, duo.sqlSave, duo.mutation, duo.hooks)
}

// SaveX is like Save, but panics if an error occurs.
func (duo *DefinitionUpdateOne) SaveX(ctx context.Context) *Definition {
	node, err := duo.Save(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// Exec executes the query on the entity.
func (duo *DefinitionUpdateOne) Exec(ctx context.Context) error {
	_, err := duo.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (duo *DefinitionUpdateOne) ExecX(ctx context.Context) {
	if err := duo.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (duo *DefinitionUpdateOne) defaults() {
	if _, ok := duo.mutation.UpdatedAt(); !ok {
		v := definition.UpdateDefaultUpdatedAt()
		duo.mutation.SetUpdatedAt(v)
	}
}

// check runs all checks and user-defined validators on the builder.
func (duo *DefinitionUpdateOne) check() error {
	if v, ok := duo.mutation.Text(); ok {
		if err := definition.TextValidator(v); err != nil {
			return &ValidationError{Name: "text", err: fmt.Errorf(`ent: validator failed for field "Definition.text": %w`, err)}
		}
	}
	return nil
}

// Modify adds a statement modifier for attaching custom logic to the UPDATE statement.
func (duo *DefinitionUpdateOne) Modify(modifiers ...func(u *sql.UpdateBuilder)) *DefinitionUpdateOne {
	duo.modifiers = append(duo.modifiers, modifiers...)
	return duo
}

func (duo *DefinitionUpdateOne) sqlSave(ctx context.Context) (_node *Definition, err error) {
	if err := duo.check(); err != nil {
		return _node, err
	}
	_spec := sqlgraph.NewUpdateSpec(definition.Table, definition.Columns, sqlgraph.NewFieldSpec(definition.FieldID, field.TypeInt))
	id, ok := duo.mutation.ID()
	if !ok {
		return nil, &ValidationError{Name: "id", err: errors.New(`ent: missing "Definition.id" for update`)}
	}
	_spec.Node.ID.Value = id
	if fields := duo.fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, definition.FieldID)
		for _, f := range fields {
			if !definition.ValidColumn(f) {
				return nil, &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
			}
			if f != definition.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, f)
			}
		}
	}
	if ps := duo.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := duo.mutation.UpdatedAt(); ok {
		_spec.SetField(definition.FieldUpdatedAt, field.TypeTime, value)
	}
	if value, ok := duo.mutation.Text(); ok {
		_spec.SetField(definition.FieldText, field.TypeString, value)
	}
	if duo.mutation.TermCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   definition.TermTable,
			Columns: []string{definition.TermColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(term.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := duo.mutation.TermIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   definition.TermTable,
			Columns: []string{definition.TermColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(term.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	_spec.AddModifiers(duo.modifiers...)
	_node = &Definition{config: duo.config}
	_spec.Assign = _node.assignValues
	_spec.ScanValues = _node.scanValues
	if err = sqlgraph.UpdateNode(ctx, duo.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{definition.Label}
		} else if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	duo.mutation.done = true
	return _node, nil
}
